#ifndef RENDER_H
#define RENDER_H

#include <QtOpenGL/QGLWidget>
#include <QBrush>
#include <QFont>
#include <QImage>
#include <QPen>
#include <QTimer>
#include <stdlib.h>
#include <math.h>
#include <QPaintEvent>
#include <QMouseEvent>
#include <QtOpenGL>
#include <QPixmap>
#include "mappysaver.h"


class GLWidget : public QGLWidget
{
    Q_OBJECT

    int x = 100;
public:
    GLWidget(QWidget *parent = 0);
    QPixmap Tileset;
    MappySaver mappa;
    QString levelname = "mappa.mp2d";
    QPixmap logo;

    ~GLWidget();

    
protected:

    void initializeGL();
        void paintEvent(QPaintEvent *event);
        void resizeGL(int width, int height);
        void mousePressEvent(QMouseEvent *event);
        void mouseMoveEvent(QMouseEvent *event);
        void timerEvent(QTimerEvent *);
        void glInit();

private:
        void setupViewport(int width, int height);


signals:
    
public slots:
    
};

#endif // RENDER_H
